Index: kernel/gr_kstd2.cc
===================================================================
--- kernel/gr_kstd2.cc	(revision 327d4171334ba3ac4cad34df7614be19f13910af)
+++ kernel/gr_kstd2.cc	(revision 1558d57b639351ad0ad10d1e5e337419bfcf21fb)
@@ -56,5 +56,5 @@
   int j = 0;
 
-  d = pFDeg((*h).p,currRing)+(*h).ecart;
+  d = currRing->pFDeg((*h).p,currRing)+(*h).ecart;
   reddeg = strat->LazyDegree+d;
   loop
@@ -106,10 +106,10 @@
       if (TEST_OPT_INTSTRATEGY)
       {
-        if (rField_is_Zp_a()) p_Content(h->p,currRing);
+        if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
         else h->pCleardenom();// also does a p_Content
       }
       /*computes the ecart*/
-      d = pLDeg((*h).p,&((*h).length),currRing);
-      (*h).FDeg=pFDeg((*h).p,currRing);
+      d = currRing->pLDeg((*h).p,&((*h).length),currRing);
+      (*h).FDeg=currRing->pFDeg((*h).p,currRing);
       (*h).ecart = d-(*h).FDeg; /*pFDeg((*h).p);*/
       if ((strat->syzComp!=0) && !strat->honey)
@@ -232,9 +232,9 @@
 
   ratGB_divide_out((*h).p);
-  d = pFDeg((*h).p,currRing)+(*h).ecart;
+  d = currRing->pFDeg((*h).p,currRing)+(*h).ecart;
   reddeg = strat->LazyDegree+d;
   if (!TEST_OPT_INTSTRATEGY)
   {
-    if (rField_is_Zp_a()) p_Content(h->p,currRing);
+    if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
     else h->pCleardenom();// also does a pContentRat
   }
@@ -273,5 +273,5 @@
         if (!TEST_OPT_INTSTRATEGY)
         {
-          if (rField_is_Zp_a()) p_Content(h->p,currRing);
+          if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
           else h->pCleardenom();// also does a p_Content
         }
@@ -291,6 +291,6 @@
         }
         ratGB_divide_out((*h).p);
-        d = pLDeg((*h).p,&((*h).length),currRing);
-        (*h).FDeg=pFDeg((*h).p,currRing);
+        d = currRing->pLDeg((*h).p,&((*h).length),currRing);
+        (*h).FDeg=currRing->pFDeg((*h).p,currRing);
         (*h).ecart = d-(*h).FDeg; /*pFDeg((*h).p);*/
         /*- try to reduce the s-polynomial again -*/
@@ -323,5 +323,5 @@
         currRing->real_var_start,currRing->real_var_end))
     {
-      int a_e=(p_Totaldegree(strat->S[j],currRing)-pFDeg(strat->S[j],currRing));
+      int a_e=(p_Totaldegree(strat->S[j],currRing)-currRing->pFDeg(strat->S[j],currRing));
 #ifdef KDEBUG
       if(TEST_OPT_DEBUG)
@@ -472,5 +472,5 @@
         if (TEST_OPT_INTSTRATEGY)
         {
-          if (rField_is_Zp_a()) p_Content(h->p,currRing);
+          if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
           else h->pCleardenom();// also does a pContent
         }
@@ -496,5 +496,5 @@
         if (TEST_OPT_INTSTRATEGY)
         {
-          if (rField_is_Zp_a()) p_Content(h->p,currRing);
+          if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
           else h->pCleardenom();// also does a p_Content
         }
@@ -525,5 +525,5 @@
   int j = 0;
   int pass = 0;
-  int reddeg = pFDeg((*h).p,currRing);
+  int reddeg = currRing->pFDeg((*h).p,currRing);
 
   if (TEST_OPT_DEBUG)
@@ -578,5 +578,5 @@
       /*- try to reduce the s-polynomial -*/
       pass++;
-      d = pFDeg((*h).p,currRing);
+      d = currRing->pFDeg((*h).p,currRing);
       if ((strat->Ll >= 0) && ((d > reddeg) || (pass > strat->LazyPass)))
       {
@@ -616,5 +616,5 @@
         if (TEST_OPT_INTSTRATEGY)
         {
-          if (rField_is_Zp_a()) p_Content(h->p,currRing);
+          if (rField_is_Zp_a(currRing)) p_Content(h->p,currRing);
           else h->pCleardenom();// also does a p_Content
         }
@@ -644,5 +644,5 @@
 
   pass = j = 0;
-  d = reddeg = pFDeg((*h).p,currRing)+(*h).ecart;
+  d = reddeg = currRing->pFDeg((*h).p,currRing)+(*h).ecart;
   if (TEST_OPT_DEBUG)
   {
@@ -737,7 +737,7 @@
       /* compute the ecart */
       if (ei <= (*h).ecart)
-        (*h).ecart = d-pFDeg((*h).p,currRing);
+        (*h).ecart = d-currRing->pFDeg((*h).p,currRing);
       else
-        (*h).ecart = d-pFDeg((*h).p,currRing)+ei-(*h).ecart;
+        (*h).ecart = d-currRing->pFDeg((*h).p,currRing)+ei-(*h).ecart;
 //      if (strat->syzComp)
 //      {
@@ -759,5 +759,5 @@
       */
       pass++;
-      d = pFDeg((*h).p,currRing)+(*h).ecart;
+      d = currRing->pFDeg((*h).p,currRing)+(*h).ecart;
       if ((strat->Ll >= 0) && ((d > reddeg) || (pass > strat->LazyPass)))
       {
@@ -825,7 +825,7 @@
 
   if (strat->honey)
-    reddeg = pFDeg((*h).p,currRing)+(*h).ecart;
+    reddeg = currRing->pFDeg((*h).p,currRing)+(*h).ecart;
   else
-    reddeg = pFDeg((*h).p,currRing);
+    reddeg = currRing->pFDeg((*h).p,currRing);
   loop
   {
@@ -924,5 +924,5 @@
       {
         pass++;
-        d = pFDeg((*h).p,currRing);
+        d = currRing->pFDeg((*h).p,currRing);
         if (strat->honey)
           d += (*h).ecart;
@@ -1017,6 +1017,6 @@
 //  {
 //     //interred  machen   Aenderung
-//     pFDegOld=pFDeg;
-//     pLDegOld=pLDeg;
+//     pFDegOld=currRing->pFDeg;
+//     pLDegOld=currRing->pLDeg;
 //  //   h=ggetid("ecart");
 //  //   if ((h!=NULL) && (IDTYP(h)==INTVEC_CMD))
@@ -1030,6 +1030,6 @@
 //      kEcartWeights(F->m,IDELEMS(F)-1,ecartWeights);
 //    }
-//    pFDeg=totaldegreeWecart;
-//    pLDeg=maxdegreeWecart;
+//    currRing->pFDeg=totaldegreeWecart;
+//    currRing->pLDeg=maxdegreeWecart;
 //    for(i=1; i<=(currRing->N); i++)
 //      Print(" %d",ecartWeights[i]);
@@ -1096,6 +1096,6 @@
     if (TEST_OPT_DEGBOUND
     && ((strat->honey
-    && (strat->L[strat->Ll].ecart+pFDeg(strat->L[strat->Ll].p,currRing)>Kstd1_deg))
-       || ((!strat->honey) && (pFDeg(strat->L[strat->Ll].p,currRing)>Kstd1_deg))))
+    && (strat->L[strat->Ll].ecart+currRing->pFDeg(strat->L[strat->Ll].p,currRing)>Kstd1_deg))
+       || ((!strat->honey) && (currRing->pFDeg(strat->L[strat->Ll].p,currRing)>Kstd1_deg))))
     {
       /*
@@ -1277,14 +1277,14 @@
   /* release temp data-------------------------------- */
   exitBuchMora(strat);
-  if (TEST_OPT_WEIGHTM)
-  {
-    pFDeg=pFDegOld;
-    pLDeg=pLDegOld;
-    if (ecartWeights)
-    {
-      omFreeSize((ADDRESS)ecartWeights,((currRing->N)+1)*sizeof(short));
-      ecartWeights=NULL;
-    }
-  }
+//  if (TEST_OPT_WEIGHTM)
+//  {
+//    currRing->pFDeg=pFDegOld;
+//    currRing->pLDeg=pLDegOld;
+//    if (ecartWeights)
+//    {
+//      omFreeSize((ADDRESS)ecartWeights,((currRing->N)+1)*sizeof(short));
+//      ecartWeights=NULL;
+//    }
+//  }
   if (TEST_OPT_PROT) messageStat(srmax,lrmax,hilbcount,strat);
   if (Q!=NULL) updateResult(strat->Shdl,Q,strat);