Index: Tst/Short/bug_division_2.res.gz.uu
===================================================================
--- Tst/Short/bug_division_2.res.gz.uu	(revision 04929b7464b309106ba29576ca010079b1acdefc)
+++ Tst/Short/bug_division_2.res.gz.uu	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -0,0 +1,10 @@
+begin 640 bug_division_2.res.gz
+M'XL("+A#A%X"`V)U9U]D:79I<VEO;E\R+G)E<P"5D<V*PR`4A?=YBDN9A7:"
+M1-/.#T$70S>%QD6;KD()+2E%<%*(9MK'KZ:-R790\'"_<P]7W16KM00`*F"S
+M_H&9-99H=9IET>Y%F`!7K%2C+,)9Y$\0`D[=I:K5GS+JVE2,-.<;,?9H0ULJ
+M(.@%@58U%V@Y)#&ZX[@V8_Y2P._1MNH.><D.;O.2QHE?A]'T$4Q2>A=]NB:.
+M3^>XUIT^@^3&UDA*/,(O`5H9"YH/(Z,\GAJ^0W[!M4L/A":!;!UA$T(#V0,'
+M7:83Q@:&<CS?9U'EIG4STUZX*R9.,%]YBKXR]*:A5^)Y\?[26_R_E,7X_G1)
+4^B_T_],91''V%CT`UU]LD_@!````
+`
+end
Index: Tst/Short/bug_division_2.stat
===================================================================
--- Tst/Short/bug_division_2.stat	(revision 04929b7464b309106ba29576ca010079b1acdefc)
+++ Tst/Short/bug_division_2.stat	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -0,0 +1,4 @@
+1 >> tst_memory_0 :: 1585726392:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:86424
+1 >> tst_memory_1 :: 1585726392:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:2150192
+1 >> tst_memory_2 :: 1585726392:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:2191296
+1 >> tst_timer_1 :: 1585726392:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:4
Index: Tst/Short/bug_division_2.tst
===================================================================
--- Tst/Short/bug_division_2.tst	(revision 04929b7464b309106ba29576ca010079b1acdefc)
+++ Tst/Short/bug_division_2.tst	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -0,0 +1,15 @@
+LIB "tst.lib";
+tst_init();
+
+ring r= 0,(x),ds;
+matrix M[2][2]=[1,0,0,0];
+matrix NN[2][1]=[1,0];
+module N=std(NN);
+list l=division(M,N);
+matrix T=l[1];
+matrix R=l[2];
+matrix U = l[3];
+matrix(M)*U;
+matrix(N)*T+matrix(R);
+
+tst_status(1);$
Index: Tst/Short/div_lift_s.res.gz.uu
===================================================================
--- Tst/Short/div_lift_s.res.gz.uu	(revision eb91f7111038dfbf967fb4ff02b2f919c13e07d2)
+++ Tst/Short/div_lift_s.res.gz.uu	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -1,34 +1,34 @@
 begin 640 div_lift_s.res.gz
-M'XL("-UC15@``V1I=E]L:69T7W,N<F5S`.5966_C-A!^]Z\@C#Y8,6V+I,X&
-M<9&B#PX0]&7KIR#09F-E2]>Q%[;2*O[U'>H84I24`[MITVT.4/HX,YR+G\GD
-MPV^_7/Q*"&%S<GGQ,QEFAVRZD9^&IX,/U0R?$P`3N979R#D=J)',YV0E_TPV
-M\BY+#M-M^M?TD-UDJ"+F9#;#-V\*;R1+#QDYW.[EEXS<[?9$Z<[`B#S(W9;<
-M[N[O;[8KU/&GIH5@2O9R^YGLM5?AG,A5>K,A\BSG])'3(]>3$4[*L_N;O'@>
-M<4<+Q+7`&N?)2&@!YL[)4$(2)"*0H"_@1#:ZO\GV,A])!\3KI5$*DC5<@]X:
-M$6'IK97>4=#'H](]TD=!<WC,'X_P"R-`.7^DN4`+WIR4NF2I'?1A(97"D:1K
-M!Q;$9Y0(ZH5Q"A:&V'\B?+LB][O5PR8EJUUZ(-M=!N5(B=R2[/>4W,G](2LE
-MT_T>2K6[O7W8[].5$H#73RG4+R7E.ANY36&M'\G'UF(?T970<)8N37?A#:4B
-MVV&8?#N7HY;+Q7+::>B1X1)<7=8(=VL'E^"62]O?_V608)C0Z<-Z8];MU7A'
-M2>CVC81M?7F&\VLJ]3;BV/R75^RZE31H?IJ7SJA'->:UAS;0\-#39GEIMO&C
-M]I(!H)JOU8128]VI:<.%BS9<!<.ZP"9LA,VZ0`U;"6+=U6+=)60Z08&BKX*_
-MD,!X:!-8P6"*A8Z*Q'+%/T`]*!_95,;CKZ4RX9I4!A\*)R<$-FEZ!Q\J0.]+
-M,L)9;#+!D#P:5&<VHN!-ZJC(KJ.'RKS9<)5,JP6;V<V[:Y%WUR+'6@AA^F^R
-M7Y/^A->*H>2_]Q&%;[.A"$PV_&ZWD@@;;-BBPT8;1IU\J`BQU>N79-0MJJW%
-M%GF^BT;PW*>YM_&#2NS_PKP>,-$?<K,QCJH>$(!U>O74D:X\S2S.$(0S;\Y/
-M/J?;$7,HH@&BW$!#1(6!1HAZ!AHCZFO4=Q$-#90A&ADH1S0V4*']=0W8T[`1
-MAZ^B*]!`GP]\X!!\AI#JG+B8%!]"8FS&7,S,A(7^3/!<5/Z,`VZ\FRM"W!,V
-M\S"><:SM<&<B&"@&7J4(TU%HO!O)#B!53&A=X8R9/V-!O:0+[Y'IE%&2`!(Z
-M@75J+P)GC!5J6H'(0N$)L..SVA!(*R>CZM4H:@`EF82%?EW$<:A=])T)+XUQ
-MOUX!)(09H=$,@6A&&-H1A9`N=,-4])KEB:QR1%:YS*Q"0Q@%B1VC5LPJ1FQ7
-MRRAS`!O$B+RHADH9UJH1M)KV`F6<\:BC7&'1,SS'],-SNYD#U96&E%]Y6]=X
-M@C7&5@]BW>HA-%1UT#D_J\Y2Q8?^@BY<1^N$2)OG`)Y?,<JN@6V(^JH&>VP.
-M2B6R56J-`0IQRE&HQZ`7QWY.NU>Q#:)=0<4U?=I#0S9NQ3;H7L=SH>O'K#NL
-MSF'"Z%,&Z_'\RJ?^-?5<UWTFUF<\U`8#95`-04\9>HL2/E\4)10^;9<,.BOW
-M7-M$S[<-IM8MTO6R*L<OK[)E^.GR!JZ+_=!G$#8#H]Z+RE#:*S48N\;]R*T+
-MT,(Y.9_4S\7.;9\-.L\1WR.LZ4W=>-9I=LQ(?;95U\@&@+)>=62^T.?@A4L7
-M!@FJF\<%G(#!AAH0Q_O'17D\3E[/C\E+^#%Y(WY,7L&/R;O@Q^1;\V-2\F/R
-M>GY,7L*/R1OQ8_)&_)C\J_R8O)H?$YL?PV*K\G*K<HU'>JOR]I\!WQV3_3,L
-M&1?)$F6R!"8K<G6R>N_*/;?EGOMRSXVYY\[<<VONN3?WW)Q[[L[=M^>^9.EK
-:=<3*?T*I_S(]'.#X?_K#Z>!OV\X@5+L:````
+M'XL("");@UX"`V1I=E]L:69T7W,N<F5S`.U92V_C-A"^^U<01@]63-M\Z-D@
+M+ESTX`!!+UN?`D.;C94M7<=>V-I6\:_O4(\A)4M.@C9HL-LX`:6/,\-Y\3.)
+M?/CME^M?"2%\2FZN?R;]])".-^I3_[+WH9P14P)@K+8J'3B7/3V2Z92LU)_Q
+M1CVD\6&\3?X:']*[%%7DE$PF^.:.X8VDR2$EA_N]^I*2A]V>:-T)&%$'M=N2
+M^]WCX]UVA3K>V+;@C\E>;3^3O?$JF!*U2NXV1%UE@CX)>A1F,L1)=?5XE^7/
+M`^$8@:@26.,\&4@CP-F4]!4D02$""?H"3J2#Q[MTK[*!<D"\6AJE(%G]->BM
+M$9$-O;76.TKZ=-2Z1_HD:0:/V=,1_F`$*!-/-)-HP9V20I<LC(,>+*13.%!T
+M[<""^(P2?K4P3L'"$/M/1&Q7Y'&W^KI)R&J7',AVET(Y$J*V)/T](0]J?T@+
+MR62_AU+M[N^_[O?)2@O`ZZ<$ZI>08IV-VB:PUH_DX\EB']&5P'*6+FQWX0VE
+MPJ;#,/EV+H<G+N?+&:>A1_H+<'51(8)5#B[`+4[9R:?'*&\#3^%>,?`VL`[W
+MS"-O`PW<JR_!V\`"[IVZS@F&"9W>KS9FU5ZU=Y2$;M\HV-8W5SB_ILIL(X'-
+M?W/+EX#7UX3FIUGAC'[48U;%T@3@8SQTC5E1F*W]ZKUD`:CF&36Y_*9+Z&OZ
+MROD+"4P$30++&4RST%&36*;Y!Z@'Y<,FE8GHGU*99#:5P9?"Q06!39H\P)<*
+MT/N"#'`6FTQR)(\:U=F-*$6=.DJR:^FA(F]-N$QFHP7KV<W::Y&UUR+#6DAI
+M^V^S7YW^I'L20\%_[R,*K\F&TO\NV%`&-38\H<-:&X:M?*@)\:37;\B@7=18
+MBQKD^2X:P67GN9>U,:_+OQ?F=8&)_E";C754=8$`&J=75Q_IBM/,_`I!./-F
+MXN)SLAUPAR+J(RHL-$!46FB(J&NA$:*>03V&:&"A'-'00@6BD85*XR^S8-?`
+M5AR>CBY'?7,^\(!#\!E"JG+","D>A,3YA#/,S(@'WD2*3);^#'UAO=LK0MPC
+M/G$QGF%D[`AG)#DH^FZI"--A8+U;R?8A55P:7>D,N3?A?K4D@_?0=LHJB0\)
+M'<$ZE1>^,\0*U:U`9(%T)=CQ>&4(I+638?EJ%=6'DHR"7+\JXC`P+GK.2!3&
+MA%>M`!+2CM!J!E_6(PR:$060+G3#5G3KY0D;Y0@;Y;*S"@UA%21RK%KQ1C&B
+M9K6L,ONP0:S(\VKHE&&M:D'K:=?7QKD(6\H5Y#TC,DP_/)\VLZ^[TI+R2F^K
+M&H^PQMCJ?F1:/8"&*@\ZLZOR+)5_Z<_IG#E&)T#:G`$XN^64+X%MB/XIA^98
+M'[1*V%2I-'HH)*A`H0Z#;A1Y&6U?I6D0[4HJE_2\AY9L=!);KWT=ET'7#SD]
+M9[`^C#@]9[`:9[<>]9;498P]$^LS'AJ#OC:H!W])7V-P=AL\7Q0M%)RW2WJM
+ME7NN;<+GVP93R_)TO:S*T<NKW#!\OKP^8]@/709A,W#JOJ@,A;U"@_,E[D?1
+MN`#-G8O9J'K.=RZCK/UH\^W#AM[TC6>=I,>45&=;?8VL`2CKED?F:W,.GC,Z
+MMTA0WSRNX00,-O2`.-X_KHOC<?QZ?HQ?PH_Q&_%C_`I^C-\%/\;_-C_&!3_&
+MK^?'^"7\&+\1/\9OQ(_Q?\J/\:OY,6[R8Y!O55%L56'PT&Q5L?R?)8ND1'FR
+M9)$LB<D*F4E6YUVYX[;<<5_NN#%WW)D[;LT=]^:.FW/'W;G]]MR5+'.M#GGQ
+73RC]7Z:O!SC^7_YPV?L;QP#LEKL:````
 `
 end
Index: Tst/Short/div_lift_s.stat
===================================================================
--- Tst/Short/div_lift_s.stat	(revision eb91f7111038dfbf967fb4ff02b2f919c13e07d2)
+++ Tst/Short/div_lift_s.stat	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1480942444:4100, 64 bit:4.1.0:x86_64-Linux:nepomuck:242224
-1 >> tst_memory_1 :: 1480942444:4100, 64 bit:4.1.0:x86_64-Linux:nepomuck:2359296
-1 >> tst_memory_2 :: 1480942444:4100, 64 bit:4.1.0:x86_64-Linux:nepomuck:2383872
-1 >> tst_timer_1 :: 1480942444:4100, 64 bit:4.1.0:x86_64-Linux:nepomuck:1
+1 >> tst_memory_0 :: 1585666850:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:223416
+1 >> tst_memory_1 :: 1585666850:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:2310144
+1 >> tst_memory_2 :: 1585666850:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:2319312
+1 >> tst_timer_1 :: 1585666850:4125, 64 bit:4.1.2:x86_64-Linux:nepomuck:4
Index: Tst/Short/ok_s.lst
===================================================================
--- Tst/Short/ok_s.lst	(revision eb91f7111038dfbf967fb4ff02b2f919c13e07d2)
+++ Tst/Short/ok_s.lst	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -5,4 +5,5 @@
 bug_content
 bug_curvepar
+bug_division_2
 bug_ecart
 bug_mem_Z
Index: kernel/ideals.cc
===================================================================
--- kernel/ideals.cc	(revision eb91f7111038dfbf967fb4ff02b2f919c13e07d2)
+++ kernel/ideals.cc	(revision 04929b7464b309106ba29576ca010079b1acdefc)
@@ -1110,11 +1110,11 @@
 }
 
-static void idLift_setUnit(int e_mod, int e_smod,matrix *unit)
+static void idLift_setUnit(int e_mod, matrix *unit)
 {
   if (unit!=NULL)
   {
-    *unit=mpNew(e_mod,e_smod);
+    *unit=mpNew(e_mod,e_mod);
     // make sure that U is a diagonal matrix of units
-    for(int i=e_smod;i>0;i--)
+    for(int i=e_mod;i>0;i--)
     {
       MATELEM(*unit,i,i)=pOne();
@@ -1142,5 +1142,5 @@
       *rest=idInit(1,mod->rank);
     }
-    idLift_setUnit(idelems_mod,idelems_submod,unit);
+    idLift_setUnit(idelems_submod,unit);
     return idInit(1,idelems_mod);
   }
@@ -1150,5 +1150,5 @@
     {
       *rest=idCopy(submod);
-      idLift_setUnit(idelems_mod,idelems_submod,unit);
+      idLift_setUnit(idelems_submod,unit);
       return idInit(1,idelems_mod);
     }
@@ -1260,5 +1260,5 @@
           if (unit!=NULL)
           {
-            *unit=mpNew(comps_to_add,comps_to_add);
+            idLift_setUnit(idelems_submod,unit);
           }
           if (rest!=NULL) *rest=idCopy(submod);
@@ -1306,5 +1306,5 @@
   if (unit!=NULL)
   {
-    *unit=mpNew(comps_to_add,comps_to_add);
+    *unit=mpNew(idelems_submod,idelems_submod);
     int i;
     for(i=0;i<IDELEMS(s_result);i++)